<?php
/*
TODO: make test to se if rss is well-formed (rss from server!)
*/

function get_rss($url,$encoding){
    if (!($get = implode ('',file ($url)))){
        die("Could not open '$url'");
    }
    if($encoding != "utf8") {
        $get = utf8_encode($get);
    }
    
    $xml_parser = xml_parser_create();
    if (!xml_parse($xml_parser, $get)) {
        die(sprintf("XML error: %s at line %d, url: %s",
            xml_error_string(xml_get_error_code($xml_parser)),
            xml_get_current_line_number($xml_parser),
            $url));
    }
    xml_parser_free($xml_parser);
    return $get;	
}
function make_file($rootspool,$url,$ttl,$encoding){
    $get = get_rss($url,$encoding);
    $newfile = $rootspool ."/".md5($url). "_" . $ttl .".rss";
    $fp = fopen($newfile, "w");
    fwrite($fp, $get);
    fclose($fp);
    return $get;
}

function scheme_tkl_rss($scheme, $path) {
    global $dir;
    $rootspool = $dir ."/rss/spool";

    $arg_str = preg_replace("/^.*?\/\?/", "", $path);
    $parms = explode("&", $arg_str);
    foreach ($parms as $arg) {
        if (preg_match("/^([^=]*)=(.*)$/", $arg, $match)) {
            $varname = $match[1];
            $value = $match[2];
            $$varname = $value;
        } else {
            die("Argument format unknown '$arg'");
        }
    }
    
    if(!strlen($ttl)) $ttl = 2600;
    if(!strlen($encoding))$encoding = "utf8";
    
    if (!strlen($url)) {
        die("Argument url must be set");
    } else if ($file) {
        if ($handle = opendir($rootspool)) {
            $filename = null;
            while (false !== ($tmp_file = readdir($handle))) { 
                if ($tmp_file != "." && $tmp_file != "..") { 
                    if(md5($url) == substr($tmp_file, 0, 32)){
                        $filename = $tmp_file;
                        $time_stamp = substr($tmp_file, 33, (strlen($tmp_file)-37));
                        $file_time = filemtime($rootspool . "/" .$filename);
                        break;	
                    }
	         }
            }
    	    closedir($handle);
        } else {
	    die("Faild to read from '$rootspool'");
	}
	//echo "$filename : $time_stamp : $file_time\n<br />"; 
    } else {
	$get = get_rss($url,$encoding);
    }
    // does the file exist.
    if($filename) { 	   		
        $filename = $rootspool . "/" .$filename;
 	if((time() > $file_time+$time_stamp)){
            unlink($filename);
            $get = make_file($rootspool,$url,$ttl,$encoding);
    	} else {
    	    $fp = fopen($filename, "r");
            $get = fread($fp, filesize ($filename));
            fclose($fp);
        }
    } else {	
        $get = make_file($rootspool,$url,$ttl,$encoding);
    }
    
    $xml = '';
    $xml .= $get;

    //echo "XML: '".$xml."'";
    return $xml;
}

    	

?>
